
! two filters

program fl

  implicit none

  integer, parameter :: ndim = 2000
  real, dimension(ndim) :: l1,l2,l3,t1,t2,t3,f
  integer :: i,n1,n2,n3
  character(len=666) :: std, our, cam
  real :: x,s

  call getarg(1,our)
  call getarg(2,std)
  call getarg(3,cam)

  call getdata(our,n1,l1,t1)
  call getdata(std,n2,l2,t2)
  if( cam /= '' ) call getdata(cam,n3,l3,t3)

  do i = 1, ndim

     x = i

     if( cam == '' ) then
        f(i) = interpol(n1,l1,t1,x)*interpol(n2,l2,t2,x)
     else
        f(i) = interpol(n1,l1,t1,x)*interpol(n2,l2,t2,x)*interpol(n3,l3,t3,x)
     end if

!     write(*,*) x,f(i),interpol(n1,l1,t1,x),interpol(n2,l2,t2,x)
  end do
     
  s = 0
  do i = 1, ndim - 1
     s = s + (f(i)+f(i+1))
  end do

  write(*,'(f10.5)') 0.5*s

contains

  subroutine getdata(name,n,l,t)

    integer :: n
    real,dimension(:) :: l,t
    character(len=*) :: name

    open(1,file=name,status="old")
    read(1,*)
    n = 1
    do 
       read(1,*,end=99) l(n), t(n)
       if( t(n) < 1e-4 ) t(n) = 0.0
       n = n + 1
    end do
99  close(1)

  end subroutine getdata

  function interpol(n,l,t,x)

    integer :: n,j,i
    real :: x,interpol
    real, dimension(:) :: l,t

    j = 0
    do i = 1, n-1
       if( l(i) < x .and. x <= l(i+1) ) then
          j = i
          exit
       end if
    end do
          
    if( j == 0 ) then
       interpol = 0.0
    else
       interpol = (t(j+1)-t(j))*(x-l(j))/(l(j+1)-l(j)) + t(j)
    end if

  end function interpol
    
end program fl
